# ent-framework

## ent-framework

- [Ent Framework](https://docs.ent-framework.net/readme.md)
- [Code Structure](https://docs.ent-framework.net/getting-started/preamble.md)
- [Connect to a Database](https://docs.ent-framework.net/getting-started/connect-to-a-database.md)
- [Create Ent Classes](https://docs.ent-framework.net/getting-started/create-ent-classes.md)
- [VC: Viewer Context and Principal](https://docs.ent-framework.net/getting-started/vc-viewer-context-and-principal.md)
- [Ent API: insert\*()](https://docs.ent-framework.net/getting-started/ent-api-insert.md)
- [Built-in Field Types](https://docs.ent-framework.net/getting-started/built-in-field-types.md)
- [Ent API: load\*() by ID](https://docs.ent-framework.net/getting-started/ent-api-load-by-id.md)
- [N+1 Selects Solution](https://docs.ent-framework.net/getting-started/n+1-selects-solution.md)
- [Automatic Batching Examples](https://docs.ent-framework.net/getting-started/automatic-batching-examples.md)
- [Ent API: select() by Expression](https://docs.ent-framework.net/getting-started/ent-api-select-by-expression.md)
- [Ent API: loadBy\*() Unique Key](https://docs.ent-framework.net/getting-started/ent-api-loadby-unique-key.md)
- [Ent API: update\*()](https://docs.ent-framework.net/getting-started/ent-api-update.md)
- [Ent API: deleteOriginal()](https://docs.ent-framework.net/getting-started/ent-api-deleteoriginal.md)
- [Ent API: count() by Expression](https://docs.ent-framework.net/getting-started/ent-api-count-by-expression.md)
- [Ent API: exists() by Expression](https://docs.ent-framework.net/getting-started/ent-api-exists-by-expression.md)
- [Ent API: selectBy() Unique Key Prefix](https://docs.ent-framework.net/getting-started/ent-api-selectby-unique-key-prefix.md)
- [Ent API: upsert\*()](https://docs.ent-framework.net/getting-started/ent-api-upsert.md)
- [Privacy Rules](https://docs.ent-framework.net/getting-started/privacy-rules.md)
- [Validators](https://docs.ent-framework.net/getting-started/validators.md)
- [Triggers](https://docs.ent-framework.net/getting-started/triggers.md)
- [Custom Field Types](https://docs.ent-framework.net/getting-started/custom-field-types.md)
- [Ent API: Configuration and Types](https://docs.ent-framework.net/ent-api-configuration-and-types.md)
- [Replication and Automatic Lag Tracking](https://docs.ent-framework.net/scalability/replication-and-automatic-lag-tracking.md)
- [Sharding and Microsharding](https://docs.ent-framework.net/scalability/sharding-microsharding.md)
- [Sharding Terminology](https://docs.ent-framework.net/scalability/sharding-terminology.md)
- [Locating a Shard and ID Format](https://docs.ent-framework.net/scalability/locating-a-shard-id-format.md)
- [Sharding Low-Level API](https://docs.ent-framework.net/scalability/sharding-low-level-api.md)
- [Shard Affinity and Ent Colocation](https://docs.ent-framework.net/scalability/shard-affinity-ent-colocation.md)
- [Inverses and Cross Shard Foreign Keys](https://docs.ent-framework.net/scalability/inverses-cross-shard-foreign-keys.md)
- [Shards Rebalancing and pg-microsharding Tool](https://docs.ent-framework.net/scalability/shards-rebalancing-and-pg-microsharding-tool.md)
- [Connection Pooling](https://docs.ent-framework.net/scalability/connection-pooling.md)
- [Database Migrations and pg-mig Tool](https://docs.ent-framework.net/advanced/database-schema-migrations.md)
- [Ephemeral (Symbol) Fields](https://docs.ent-framework.net/advanced/ephemeral-symbol-fields.md)
- [Atomic Updates and CAS](https://docs.ent-framework.net/advanced/atomic-updates-and-cas.md)
- [Custom Field Refactoring](https://docs.ent-framework.net/advanced/custom-field-refactoring.md)
- [VC Flavors](https://docs.ent-framework.net/advanced/vc-flavors.md)
- [Query Cache and VC Caches](https://docs.ent-framework.net/advanced/query-and-custom-caches.md)
- [Loaders and Custom Batching](https://docs.ent-framework.net/advanced/loaders-and-custom-batching.md)
- [PostgreSQL Specific Features](https://docs.ent-framework.net/advanced/postgresql-specific-features.md)
- [Query Planner Hints](https://docs.ent-framework.net/advanced/query-planner-hints.md)
- [Cluster Maintenance Queries](https://docs.ent-framework.net/advanced/cluster-maintenance-queries.md)
- [Logging and Diagnostic Tools](https://docs.ent-framework.net/advanced/logging-and-diagnostic-tools.md)
- [Composite Primary Keys](https://docs.ent-framework.net/advanced/composite-primary-keys.md)
- [Passwords Rotation](https://docs.ent-framework.net/advanced/passwords-rotation.md)
- [Abstraction Layers](https://docs.ent-framework.net/architecture/abstraction-layers.md)
- [Ent Framework, Meta’s TAO, entgo](https://docs.ent-framework.net/architecture/ent-framework-metas-tao-entgo.md)
- [JIT in SQL Queries Batching](https://docs.ent-framework.net/architecture/jit-in-sql-queries-batching.md)
- [To JOIN or not to JOIN](https://docs.ent-framework.net/architecture/to-join-or-not-to-join.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information, you can query the documentation dynamically by asking a question.
Perform an HTTP GET request on a page URL with the `ask` query parameter:
```
GET https://docs.ent-framework.net/readme.md?ask=<question>
```
The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.
Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
